#!/usr/bin/python
from __future__ import division
import matplotlib
matplotlib.use("Agg")
from matplotlib import rc
matplotlib.rc('text', usetex=True)
# Use sans-serif fonts to match with beamer
matplotlib.rc('font', family='sans-serif')
# matplotlib.rc('mathtext', fontset='custom', rm='sans', it='sans:italic')
# matplotlib.rc('mathtext', fontset='stixsans')
# matplotlib.rc('text.latex',preamble=r'\def\mathfamilydefault{\sfdefault},\def\familydefault{\sfdefault}')
# Hack courtesy of Peter-Jan Randewijk
# http://www.mail-archive.com/matplotlib-users@lists.sourceforge.net/msg02040.html
matplotlib.rc('text.latex',preamble=r"""
%---------------------------------------------------------------------
% Stolen from "beamerbasefont.sty"
%---------------------------------------------------------------------
\newcommand{\mathfamilydefault}{\sfdefault}

\DeclareSymbolFont{numbers}{\encodingdefault}{\mathfamilydefault}{m}{n}
\DeclareSymbolFont{pureletters}{\encodingdefault}{\mathfamilydefault}{m}{it}
\SetMathAlphabet{\mathrm}{normal}{\encodingdefault}{\rmdefault}{m}{n}
\DeclareMathAlphabet{\mathbf}{\encodingdefault}{\mathfamilydefault}{bx}{n}
\DeclareMathAlphabet{\mathsf}{\encodingdefault}{\sfdefault}{m}{n}
\DeclareMathAlphabet{\mathit}{\encodingdefault}{\mathfamilydefault}{m}{it}
\DeclareMathAlphabet{\mathtt}{\encodingdefault}{\ttdefault}{m}{n}

\SetSymbolFont{numbers}{bold}{\encodingdefault}{\mathfamilydefault}{bx}{n}
\SetSymbolFont{pureletters}{bold}{\encodingdefault}{\mathfamilydefault}{bx}{it}
\SetMathAlphabet{\mathrm}{bold}{\encodingdefault}{\rmdefault}{bx}{n}
\SetMathAlphabet{\mathbf}{bold}{\encodingdefault}{\mathfamilydefault}{bx}{n}
\SetMathAlphabet{\mathsf}{bold}{\encodingdefault}{\sfdefault}{bx}{n}
\SetMathAlphabet{\mathit}{bold}{\encodingdefault}{\mathfamilydefault}{bx}{it}
\SetMathAlphabet{\mathtt}{bold}{\encodingdefault}{\ttdefault}{bx}{n}

\DeclareMathSymbol{0}\mathalpha{numbers}{"30}
\DeclareMathSymbol{1}\mathalpha{numbers}{"31}
\DeclareMathSymbol{2}\mathalpha{numbers}{"32}
\DeclareMathSymbol{3}\mathalpha{numbers}{"33}
\DeclareMathSymbol{4}\mathalpha{numbers}{"34}
\DeclareMathSymbol{5}\mathalpha{numbers}{"35}
\DeclareMathSymbol{6}\mathalpha{numbers}{"36}
\DeclareMathSymbol{7}\mathalpha{numbers}{"37}
\DeclareMathSymbol{8}\mathalpha{numbers}{"38}
\DeclareMathSymbol{9}\mathalpha{numbers}{"39}

\DeclareMathSymbol{A}\mathalpha{pureletters}{"41}
\DeclareMathSymbol{B}\mathalpha{pureletters}{"42}
\DeclareMathSymbol{C}\mathalpha{pureletters}{"43}
\DeclareMathSymbol{D}\mathalpha{pureletters}{"44}
\DeclareMathSymbol{E}\mathalpha{pureletters}{"45}
\DeclareMathSymbol{F}\mathalpha{pureletters}{"46}
\DeclareMathSymbol{G}\mathalpha{pureletters}{"47}
\DeclareMathSymbol{H}\mathalpha{pureletters}{"48}
\DeclareMathSymbol{I}\mathalpha{pureletters}{"49}
\DeclareMathSymbol{J}\mathalpha{pureletters}{"4A}
\DeclareMathSymbol{K}\mathalpha{pureletters}{"4B}
\DeclareMathSymbol{L}\mathalpha{pureletters}{"4C}
\DeclareMathSymbol{M}\mathalpha{pureletters}{"4D}
\DeclareMathSymbol{N}\mathalpha{pureletters}{"4E}
\DeclareMathSymbol{O}\mathalpha{pureletters}{"4F}
\DeclareMathSymbol{P}\mathalpha{pureletters}{"50}
\DeclareMathSymbol{Q}\mathalpha{pureletters}{"51}
\DeclareMathSymbol{R}\mathalpha{pureletters}{"52}
\DeclareMathSymbol{S}\mathalpha{pureletters}{"53}
\DeclareMathSymbol{T}\mathalpha{pureletters}{"54}
\DeclareMathSymbol{U}\mathalpha{pureletters}{"55}
\DeclareMathSymbol{V}\mathalpha{pureletters}{"56}
\DeclareMathSymbol{W}\mathalpha{pureletters}{"57}
\DeclareMathSymbol{X}\mathalpha{pureletters}{"58}
\DeclareMathSymbol{Y}\mathalpha{pureletters}{"59}
\DeclareMathSymbol{Z}\mathalpha{pureletters}{"5A}

\DeclareMathSymbol{a}\mathalpha{pureletters}{"61}
\DeclareMathSymbol{b}\mathalpha{pureletters}{"62}
\DeclareMathSymbol{c}\mathalpha{pureletters}{"63}
\DeclareMathSymbol{d}\mathalpha{pureletters}{"64}
\DeclareMathSymbol{e}\mathalpha{pureletters}{"65}
\DeclareMathSymbol{f}\mathalpha{pureletters}{"66}
\DeclareMathSymbol{g}\mathalpha{pureletters}{"67}
\DeclareMathSymbol{h}\mathalpha{pureletters}{"68}
\DeclareMathSymbol{i}\mathalpha{pureletters}{"69}
\DeclareMathSymbol{j}\mathalpha{pureletters}{"6A}
\DeclareMathSymbol{k}\mathalpha{pureletters}{"6B}
\DeclareMathSymbol{l}\mathalpha{pureletters}{"6C}
\DeclareMathSymbol{m}\mathalpha{pureletters}{"6D}
\DeclareMathSymbol{n}\mathalpha{pureletters}{"6E}
\DeclareMathSymbol{o}\mathalpha{pureletters}{"6F}
\DeclareMathSymbol{p}\mathalpha{pureletters}{"70}
\DeclareMathSymbol{q}\mathalpha{pureletters}{"71}
\DeclareMathSymbol{r}\mathalpha{pureletters}{"72}
\DeclareMathSymbol{s}\mathalpha{pureletters}{"73}
\DeclareMathSymbol{t}\mathalpha{pureletters}{"74}
\DeclareMathSymbol{u}\mathalpha{pureletters}{"75}
\DeclareMathSymbol{v}\mathalpha{pureletters}{"76}
\DeclareMathSymbol{w}\mathalpha{pureletters}{"77}
\DeclareMathSymbol{x}\mathalpha{pureletters}{"78}
\DeclareMathSymbol{y}\mathalpha{pureletters}{"79}
\DeclareMathSymbol{z}\mathalpha{pureletters}{"7A}
""")
import matplotlib.pyplot as plt
from matplotlib import cm
import numpy as np
from ConfigParser import SafeConfigParser
import matplotlib.font_manager as ftmgr
from scipy import stats

def float_or_nan(str):
    if str == '-':
        return  np.nan
    else:
        return float(str)

def parse_submission(subfile,length=50):
    submission = {
        'PULSAR_INDEX' : np.empty(length,dtype=int),
        'PULSAR_FSTART' : np.empty(length,dtype=int),
        'PULSAR_FEND' : np.empty(length,dtype=int),
        'DETECTION' : np.empty(length,dtype=bool),
        'P_VALUE' : np.empty(length,dtype=float),
        'H0_UL'  : np.empty(length,dtype=float),
        'H0_EST' : np.empty(length,dtype=float),
        'H0_ERR' : np.empty(length,dtype=float),
        'F0_ESTIMATE' : np.empty(length,dtype=float),
        'F0_ERROR' : np.empty(length,dtype=float),
        'ASINI_EST' : np.empty(length,dtype=float),
        'ASINI_ERR' : np.empty(length,dtype=float),
        'PERIOD_EST' : np.empty(length,dtype=float),
        'PERIOD_ERR' : np.empty(length,dtype=float),
        'TASC_EST' : np.empty(length,dtype=float),
        'TASC_ERR' : np.empty(length,dtype=float)
        }
    i = 0
    for line in subfile:
        if line[0] == '%':
            continue
        (idx, fstart, fend, detect, pval, h0ul, h0, h0err,
         f0, f0err, asini, asinierr, P, Perr, Tasc, Tascerr
         ) = line.split()
        submission['PULSAR_INDEX'][i] = int(idx)
        submission['PULSAR_FSTART'][i] = int(fstart)
        submission['PULSAR_FEND'][i] = int(fend)
        if detect == 'yes':
            submission['DETECTION'][i] = True
        elif detect == 'no':
            submission['DETECTION'][i] = False
        else:
            raise(ValueError, ('%s not recognized; must be "yes" or "no"'
                                % detect))
        submission['P_VALUE'][i] = float_or_nan(pval)
        submission['H0_UL'][i] = float_or_nan(h0ul)
        submission['H0_EST'][i] = float_or_nan(h0)
        submission['H0_ERR'][i] = float_or_nan(h0err)
        submission['F0_ESTIMATE'][i] = float_or_nan(f0)
        submission['F0_ERROR'][i] = float_or_nan(f0err)
        submission['ASINI_EST'][i] = float_or_nan(asini)
        submission['ASINI_ERR'][i] = float_or_nan(asinierr)
        submission['PERIOD_EST'][i] = float_or_nan(P)
        submission['PERIOD_ERR'][i] = float_or_nan(Perr)
        submission['TASC_EST'][i] = float_or_nan(Tasc)
        submission['TASC_ERR'][i] = float_or_nan(Tascerr)
        i = i + 1
    return submission

def sigmoid_posterior_stuff(logx, quantity, search, detected, xvals,
                            weight = None,
                            jeffprior = False,
                            alogscale = False,
                            alphapow = 1.,
                            na = 200, nb = 200,
                            levels = [0.05,0.25,0.50,0.75,0.95],
                            amin=1, amax=20, bmin=None, bmax=None):
    if bmin is None:
        bmin = min(logx)
    if bmax is None:
        bmax = max(logx)

    if alogscale:
        alpha = np.logspace(np.log(amin),np.log(amax),na,base=np.e)
    else:
        alpha = np.linspace(amin,amax,na)

    beta = np.linspace(bmin,bmax,nb)
    bg,ag = np.meshgrid(beta,alpha)

# Figure out which signal strengths to use for Jeffreys prior
    if jeffprior is False:
        prior = ag**(-alphapow)
    else:
        if jeffprior is True:
            jeffprior = logx

        eff = 1. / ( 1.
                     + np.exp( -ag[:,:,None]
                                * (jeffprior[None,None,:]-bg[:,:,None]) )
                     )
        e1me = eff * (1.-eff)
        prior = ag * np.sqrt(
            e1me[:,:,:,None] * e1me[:,:,None,:]
            * ( ( jeffprior[:,None] - jeffprior[None,:] )**2 )[None,None,:,:]
            ).sum(axis=-1).sum(axis=-1)

    if weight is None:
        weight = np.ones_like(detected)
    else:
        detected *= weight

#     print detected

    if len(logx):
        likelihood = (
            np.exp( -ag[:,:,None] * (logx[None,None,:]-bg[:,:,None])
                     * (weight-detected)[None,None,:] )
            / (
                1+np.exp(-ag[:,:,None]*(logx[None,None,:]-bg[:,:,None]))
                )**weight[None,None,:]
            ).prod(axis=-1)
    else:
        likelihood = np.ones_like(prior)

    posterior = prior * likelihood
    if alogscale:
        posterior *= ag
        prior *= ag

    prior /= prior.sum()
    posterior /= posterior.sum()

    fig = plt.figure();
    fig.set_size_inches(5,3);
    ax = fig.add_subplot(111)

    if jeffprior is not False:
        if alogscale:
            ax.contourf(bg,np.log10(ag),prior,cmap=cm.gnuplot2)
#             ax.scatter(bg,np.log10(ag),c=prior,linewidth=0,cmap=cm.gnuplot2)
            ax.set_ylim([np.log10(amin),np.log10(amax)])
            ax.set_ylabel(r'$\log_{10}\alpha$')
        else:
            ax.contourf(bg,ag,prior,cmap=cm.gnuplot2)
#             ax.scatter(bg,ag,c=prior,linewidth=0,cmap=cm.gnuplot2)
            ax.set_ylim([amin,amax])
            ax.set_ylabel(r'$\alpha$')

        ax.set_xlim([bmin,bmax])
        ax.set_xlabel(r'$\beta$')
        ax.set_title(r'$f(\alpha,\beta|I)$ for %s search' % (search))

        fig.savefig('%s_%s_prior.eps'  % (quantity,search),bbox_inches='tight')
#         fig.savefig('%s_%s_prior.png'  % (quantity,search),bbox_inches='tight')
        plt.close(fig)


    fig = plt.figure();
    fig.set_size_inches(5,3);
    ax = fig.add_subplot(111)

    if alogscale:
        ax.contourf(bg,np.log10(ag),posterior,cmap=cm.gnuplot2)
#         ax.scatter(bg,np.log10(ag),c=posterior,linewidth=0,cmap=cm.gnuplot2)
        ax.set_ylim([np.log10(amin),np.log10(amax)])
        ax.set_ylabel(r'$\log_{10}\alpha$')
    else:
        ax.contourf(bg,ag,posterior,cmap=cm.gnuplot2)
#         ax.scatter(bg,ag,c=posterior,linewidth=0,cmap=cm.gnuplot2)
        ax.set_ylim([amin,amax])
        ax.set_ylabel(r'$\alpha$')

    ax.set_xlim([bmin,bmax])
    ax.set_xlabel(r'$\beta$')
    ax.set_title(r'$f(\alpha,\beta|{D_i},I)$ for %s search' % (search))

    fig.savefig('%s_%s_post.eps'  % (quantity,search),bbox_inches='tight')
#     fig.savefig('%s_%s_post.png'  % (quantity,search),bbox_inches='tight')
    plt.close(fig)

    nx = len(xvals)

    alph = ag.flatten()
    bet = bg.flatten()
    post = posterior.flatten()
    e_alphbet = np.exp(alph*bet)
#     print e_alphbet
    npct = len(levels)
    pctiles = np.empty((npct,nx))

    for ix in xrange(nx):
        x = xvals[ix]
        x_alpha = x**alph
        px = x_alpha / (x_alpha+e_alphbet)
        inds = np.argsort(px)
        cdf = post[inds].cumsum()
        px_sorted = px[inds]
        for ip in xrange(npct):
            pctiles[ip,ix] = px_sorted[cdf<=levels[ip]][-1]

    fig = plt.figure();
    fig.set_size_inches(5,3);

    ax = fig.add_subplot(111)

    for ip in xrange(npct):
        ax.semilogx(xvals,pctiles[ip,:],'-x',label=('%.2f' % levels[ip]))

    if search == 'PN' or search == 'SB':
        ax.legend(loc='lower left')
    else:
        ax.legend(loc='lower right')
    ax.set_xlabel(r'$x_0$')
    ax.set_ylim([-0.01,1.01])
    ax.set_ylabel(r'$\varepsilon_0$')
    ax.set_title(r'$f(\varepsilon_0|{D_i},I)$ percentiles for %s search' % (search))
    ax.grid(True)

    if min(xvals) > 0.1:
        ax.set_xlim([5e-1,2e+1])
        tickvals = [1,2,5,10]
        ticklabs = [(r'$%d$' % v) for v in tickvals]
    else:
        ax.set_xlim([5e-2,2e+0])
        tickvals = [0.1,0.2,0.5,1.0]
        ticklabs = [(r'$%.1f$' % v) for v in tickvals]
    ax.set_xticks(tickvals)
    ax.set_xticklabels(ticklabs)
    fig.savefig('%s_%s_pctiles.eps'  % (quantity,search),bbox_inches='tight')

    if len(logx):
        xinds = np.argsort(logx)
        ax.semilogx(np.exp(logx[xinds]),detected[xinds],'k-*')
        if min(xvals) > 0.1:
            ax.set_xlim([5e-1,2e+1])
            tickvals = [1,2,5,10]
            ticklabs = [(r'$%d$' % v) for v in tickvals]
        else:
            ax.set_xlim([5e-2,2e+0])
            tickvals = [0.1,0.2,0.5,1.0]
            ticklabs = [(r'$%.1f$' % v) for v in tickvals]
        ax.set_xticks(tickvals)
        ax.set_xticklabels(ticklabs)
        fig.savefig('%s_%s_pctiles_res.eps'
                    % (quantity,search),bbox_inches='tight')
    plt.close(fig)

fig = plt.figure();
fig.set_size_inches(5,3);

ax = fig.add_subplot(111)

lnxmax = 3.5
lnx = np.linspace(-lnxmax,lnxmax,500)
eps = 1./(1.+np.exp(-lnx))

ax.plot(lnx,eps,'b-')
tickvals = [-3,-2,-1,0,1,2,3]
ticklabs = [r'$\beta-\frac{3}{\alpha}$',
            r'$\beta-\frac{2}{\alpha}$',
            r'$\beta-\frac{1}{\alpha}$',
            r'$\beta$',
            r'$\beta+\frac{1}{\alpha}$',
            r'$\beta+\frac{2}{\alpha}$',
            r'$\beta+\frac{3}{\alpha}$']
ax.set_xticks(tickvals)
ax.set_xticklabels(ticklabs)
ax.set_xlabel(r'$\ln x$')
ax.set_xlim([-lnxmax,lnxmax])
ax.set_ylabel(r'$\varepsilon(x;\alpha,\beta)$')
ax.set_ylim([0,1])
ax.grid(True)

fig.savefig('sigmoid.eps',bbox_inches='tight')
plt.close(fig)

fig = plt.figure();
fig.set_size_inches(5,3);

ax = fig.add_subplot(111)
eff = np.linspace(0,1,1000)[1:-1]
pbayes = stats.beta.pdf(eff,1,1)
pjeff = stats.beta.pdf(eff,0.5,0.5)
phald = stats.beta.pdf(eff,5e-3,5e-3)

ax.plot(eff,pbayes,'b-',label='Bayes-Laplace')
ax.plot(eff,pjeff,'g-',label='Jeffreys')
ax.plot(eff,phald,'r-',label='Haldane')

ax.legend(loc='upper center')
ax.set_xlim([0,1])
ax.set_xlabel(r'$\varepsilon$')
ax.set_ylim([0,2])
ax.set_ylabel(r'$f(\varepsilon|I)$')
ax.grid(True)
ax.set_title('Prior pdf for efficiency')

fig.savefig('binpriors.eps',bbox_inches='tight')
plt.close(fig)

fig = plt.figure();
fig.set_size_inches(5,3);

ax = fig.add_subplot(111)
eff = np.linspace(0,1,1000)[1:-1]
postbayes = stats.beta.pdf(eff,5+1,1)
postjeff = stats.beta.pdf(eff,5+0.5,0.5)
posthald = stats.beta.pdf(eff,5+5e-3,5e-3)

ax.plot(eff,postbayes,'b-',label='Bayes-Laplace')
ax.plot(eff,postjeff,'g-',label='Jeffreys')
ax.plot(eff,posthald,'r-',label='Haldane')

ax.legend(loc='upper center')
ax.set_xlim([0,1])
ax.set_xlabel(r'$\varepsilon$')
ax.set_ylim([0,2])
ax.set_ylabel(r'$f(\varepsilon|D,I)$')
ax.grid(True)
ax.set_title('Posterior after five successes')

fig.savefig('binposts.eps',bbox_inches='tight')

ax.set_ylim([0,10])

fig.savefig('binpostsout.eps',bbox_inches='tight')
plt.close(fig)

ccClosed = parse_submission(open('submission_CrossCorr.txt'))
tsClosed = parse_submission(open('submission_TwoSpect.txt'))
rmClosed = parse_submission(open('submission_radiometer.txt'))
sbClosed = parse_submission(open('submission_sideband.txt'))
pnClosed = parse_submission(open('submission_polynomial.txt'))

sigcp = SafeConfigParser()
sigcp.optionxform = str
sigcp.read('MDCv6_closed.txt')

signals = sigcp.sections()

h0Closed = np.array([(sigcp.getfloat(sec,'h0')*1e25) for sec in signals])
h0inds = np.argsort(h0Closed)

fig = plt.figure();
fig.set_size_inches(5,3);

ax = fig.add_subplot(111)
ax.semilogx(h0Closed[h0inds],ccClosed['DETECTION'][h0inds],'k-*')
ax.set_xlim([5e-1,2e+1])
ax.set_xlabel(r'$x_i$')
ax.set_ylim([-0.1,1.1])
ax.set_ylabel(r'$D_i$')
tickvals = [1,2,5,10]
ticklabs = [(r'$%d$' % v) for v in tickvals]
ax.set_xticks(tickvals)
ax.set_xticklabels(ticklabs)
ax.set_yticks([0,1])
ax.set_title('Detection for CC search')
ax.grid(True)

fig.savefig('signalstrengths_CC.eps',bbox_inches='tight')
plt.close(fig)

fig = plt.figure();
fig.set_size_inches(5,3);

ax = fig.add_subplot(111)
ax.semilogx(h0Closed[h0inds],tsClosed['DETECTION'][h0inds],'k-*')
ax.set_xlim([5e-1,2e+1])
ax.set_xlabel(r'$x_i$')
ax.set_ylim([-0.1,1.1])
ax.set_ylabel(r'$D_i$')
tickvals = [1,2,5,10]
ticklabs = [(r'$%d$' % v) for v in tickvals]
ax.set_xticks(tickvals)
ax.set_xticklabels(ticklabs)
ax.set_yticks([0,1])
ax.set_title('Detection for TS search')
ax.grid(True)

fig.savefig('signalstrengths_TS.eps',bbox_inches='tight')
plt.close(fig)

fig = plt.figure();
fig.set_size_inches(5,3);

ax = fig.add_subplot(111)
ax.semilogx(h0Closed[h0inds],rmClosed['DETECTION'][h0inds],'k-*')
ax.set_xlim([5e-1,2e+1])
ax.set_xlabel(r'$x_i$')
ax.set_ylim([-0.1,1.1])
ax.set_ylabel(r'$D_i$')
tickvals = [1,2,5,10]
ticklabs = [(r'$%d$' % v) for v in tickvals]
ax.set_xticks(tickvals)
ax.set_xticklabels(ticklabs)
ax.set_yticks([0,1])
ax.set_title('Detection for RM search')
ax.grid(True)

fig.savefig('signalstrengths_RM.eps',bbox_inches='tight')
plt.close(fig)

fig = plt.figure();
fig.set_size_inches(5,3);

ax = fig.add_subplot(111)
ax.semilogx(h0Closed[h0inds],sbClosed['DETECTION'][h0inds],'k-*')
ax.set_xlim([5e-1,2e+1])
ax.set_xlabel(r'$x_i$')
ax.set_ylim([-0.1,1.1])
ax.set_ylabel(r'$D_i$')
tickvals = [1,2,5,10]
ticklabs = [(r'$%d$' % v) for v in tickvals]
ax.set_xticks(tickvals)
ax.set_xticklabels(ticklabs)
ax.set_yticks([0,1])
ax.set_title('Detection for SB search')
ax.grid(True)

fig.savefig('signalstrengths_SB.eps',bbox_inches='tight')
plt.close(fig)

fig = plt.figure();
fig.set_size_inches(5,3);

ax = fig.add_subplot(111)
ax.semilogx(h0Closed[h0inds],pnClosed['DETECTION'][h0inds],'k-*')
ax.set_xlim([5e-1,2e+1])
ax.set_xlabel(r'$x_i$')
ax.set_ylim([-0.1,1.1])
ax.set_ylabel(r'$D_i$')
tickvals = [1,2,5,10]
ticklabs = [(r'$%d$' % v) for v in tickvals]
ax.set_xticks(tickvals)
ax.set_xticklabels(ticklabs)
ax.set_yticks([0,1])
ax.set_title('Detection for PN search')
ax.grid(True)

fig.savefig('signalstrengths_PN.eps',bbox_inches='tight')
plt.close(fig)

h0vals = np.logspace(np.log10(5e-1),np.log10(2e+2))

sigmoid_posterior_stuff(logx = np.log(h0Closed),
                        alogscale = True,
                        jeffprior = False,
                        quantity = 'h0',
                        search = 'PN',
                        detected = pnClosed['DETECTION'],
                        xvals = h0vals,
                        amin = 2.0,
                        amax = 20,
                        bmin = 1.9,
                        bmax = 2.7
                        )

sigmoid_posterior_stuff(logx = np.log(h0Closed),
                        alogscale = True,
                        jeffprior = False,
                        quantity = 'h0',
                        search = 'SB',
                        detected = sbClosed['DETECTION'],
                        xvals = h0vals,
                        amin = 2.0,
                        amax = 10,
                        bmin = 1.4,
                        bmax = 2.0
                        )

sigmoid_posterior_stuff(logx = np.log(h0Closed),
                        alogscale = True,
                        jeffprior = False,
                        quantity = 'h0',
                        search = 'RM',
                        detected = rmClosed['DETECTION'],
                        xvals = h0vals,
                        amin = 1.3,
                        amax = 7,
                        bmin = 0.8,
                        bmax = 1.5
                        )

sigmoid_posterior_stuff(logx = np.log(h0Closed),
                        alogscale = True,
                        jeffprior = False,
                        quantity = 'h0',
                        search = 'TS',
                        detected = tsClosed['DETECTION'],
                        xvals = h0vals,
                        amin = 0.9,
                        amax = 7,
                        bmin = 0.3,
                        bmax = 1.2
                        )

sigmoid_posterior_stuff(logx = np.log(h0Closed),
                        alogscale = True,
                        jeffprior = False,
                        quantity = 'h0',
                        search = 'CC',
                        detected = ccClosed['DETECTION'],
                        xvals = h0vals,
                        amin = 0.3,
                        amax = 50,
                        # na = 400,
                        # nb = 400,
                        bmin = -6,
                        bmax = 0.3
                        )

sigmoid_posterior_stuff(logx = np.log(h0Closed),
                        alogscale = True,
                        jeffprior = True,
                        quantity = 'h0',
                        search = 'TSjeff',
                        detected = tsClosed['DETECTION'],
                        xvals = h0vals,
                        amin = 0.9,
                        amax = 7,
                        bmin = 0.3,
                        bmax = 1.2
                        )

sigmoid_posterior_stuff(logx = np.log(h0Closed),
                        alogscale = True,
                        jeffprior = True,
                        quantity = 'h0',
                        search = 'CCjeff',
                        detected = ccClosed['DETECTION'],
                        xvals = h0vals,
                        amin = 0.3,
                        amax = 50,
                        # na = 400,
                        # nb = 400,
                        bmin = -6,
                        bmax = 0.3
                        )

sigmoid_posterior_stuff(logx = np.log(h0Closed),
                        alogscale = True,
                        jeffprior = True,
                        quantity = 'h0',
                        search = 'CCjeff2',
                        detected = ccClosed['DETECTION'],
                        xvals = 0.1*h0vals,
                        amin = 0.3,
                        amax = 50,
                        # na = 400,
                        # nb = 400,
                        bmin = -6,
                        bmax = 0.3
                        )

sigmoid_posterior_stuff(logx = np.log([]),
                        alogscale = True,
                        jeffprior = np.log(h0Closed),
                        quantity = 'h0',
                        search = 'jeff',
                        detected = ccClosed['DETECTION'],
                        xvals = h0vals,
                        amin = 0.5,
                        amax = 200,
                        # na = 400,
                        # nb = 400,
                        bmin = -0.5,
                        bmax = 3
                        )
